<template>
  <div class="app-container">
    <div style="display: flex;justify-content: space-between;margin-bottom: 20px">
      <el-form :inline="true" style="display: flex;align-items: center;flex-wrap: wrap;" >
        <el-radio-group v-model="queryParams.status" @change="getList">
          <el-radio-button label="" >全部</el-radio-button>
          <el-radio-button label="0">签署中</el-radio-button>
          <el-radio-button label="2" >已归档</el-radio-button>
        </el-radio-group>
<!--        <el-form-item label="仓库名称：" >-->
<!--          <el-input v-model="data.queryParams.name" placeholder="请输仓库名称"></el-input>-->
<!--        </el-form-item>-->
<!--        <el-form-item >-->
<!--          <el-button-->
<!--              type="primary"-->
<!--              @click="getList"-->
<!--          >查询</el-button>-->
<!--          <el-button-->
<!--              type="primary"-->
<!--              plain-->
<!--              @click="reset"-->
<!--          >重置</el-button>-->
<!--        </el-form-item>-->
      </el-form>
    </div>
    <!-- 表格数据 -->
    <el-table v-loading="loading" :data="dataList" :border="true">
      <el-table-column label="序号" type="index" align="center" width="80" />
      <el-table-column label="项目名称" prop="itemName" align="center"  />
      <el-table-column label="模板ID" prop="templateId" align="center" />
      <el-table-column label="发起部门" prop="deptName" align="center" />
      <el-table-column label="发起时间" prop="originateTime" align="center" />
      <el-table-column label="最初签署人" prop="initiaiUserName" align="center" />
      <el-table-column label="流转记录" prop="count" align="center" >
        <template #default="scope">
          <span style="color: #1890ff;cursor: pointer" @click="record(scope.row)">{{scope.row.flowCount}}</span>
        </template>
      </el-table-column>
      <el-table-column label="签署状态" prop="itemStatus" align="center" >
        <template #default="scope">
          <span>{{scope.row.itemStatus == 0 ? '签署中' : scope.row.itemStatus == 1 ? '已签署' :scope.row.itemStatus == 2 ? '已归档' : ''  }}</span>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="250" >
        <template #default="scope">
          <el-button link type="primary" @click="view(scope.row)">预览</el-button>
          <el-button link type="primary" v-if="scope.row.itemStatus !=2 && (data.userRole.includes('admin') || data.userRole.includes('suprice') ) " @click="circulationBtn(scope.row)" >流转</el-button>
          <el-button link type="primary" v-if="scope.row.itemStatus !=2 &&(data.userRole.includes('admin') || data.userRole.includes('suprice')) && scope.row.isAbleArchive " @click="archiveBtn(scope.row)">确认归档</el-button>
          <el-button link type="danger" @click="handleDelete(scope.row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
        v-show="total > 0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList"
    />
    <circulation ref="circulationRef" @getList="getList"></circulation>
    <timeRecord ref="timeRecordRef" @getList="getList"></timeRecord>
    <view-p ref="viewPRef" @getList="getList"></view-p>
    <sign-file ref="signFileRef" @getList="getList"></sign-file>
  </div>
</template>

<script setup>
import {getCurrentInstance, onMounted, onUnmounted, reactive, ref, toRefs} from "vue";
import {ElMessage, ElMessageBox} from "element-plus";
import circulation from './components/circulation'
import timeRecord from './components/record.vue'
import viewP from './components/viewPdf.vue'
import signFile from './components/signFile.vue'

import {delSignProject, getSignProject, signArchive} from "@/api/signAgreement/signProject";
import Cookies from "js-cookie";
const { proxy } = getCurrentInstance();
const loading = ref(false);
const dialogRef = ref();
const circulationRef = ref();
const viewPRef = ref();
const timeRecordRef = ref()
const signFileRef = ref()
const data = reactive({
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    status: ''
  },
  userRole:[],
  user: {},
  total: 0,
  dataList: []
});

const { queryParams, total, dataList } = toRefs(data);
const classHourRef = ref();
onMounted(()=>{
  getList()
  data.userRole = JSON.parse(Cookies.get('userRole'))
  data.user = JSON.parse(Cookies.get('userInfo'))
})

onUnmounted(()=>{

})

const getList = async () => {
  loading.value = true
  const res = await getSignProject(data.queryParams)
  if(res.code == 200){
    data.dataList = res.rows.map(item => {
      return {
        ...item,
        flowCount: item.signatureFlows && item.signatureFlows.length >0 ? item.signatureFlows.length : 0
      }
    })
    data.dataList.forEach(item => {
      let isAble = true
      item.signatureFlows.forEach(i => {
        if(i.signStatus !=1){
          isAble = false
        }
      })
      item.isAbleArchive = isAble
    })
    data.total = res.total
  }else{
    ElMessage.warning(res.message)
  }
  loading.value = false
}

const openDialog = (type, value) => {
  dialogRef.value.openDialog(type, value);
}
const record = (val) => {
  if(val.flowCount > 0){
    timeRecordRef.value.openDialog(val)
  }else {
    ElMessage.warning('暂无流转记录')
  }

}

const circulationBtn = (value) => {
  circulationRef.value.openDialog(value)
}
const view = (val) => {
  viewPRef.value.openDialog(val)
}
const archiveBtn = (val) => {
  signFileRef.value.openDialog(val)
  // ElMessageBox.confirm(
  //     '确定项目归档？',
  //     '提示',
  //     {
  //       confirmButtonText: '确定',
  //       cancelButtonText: '取消',
  //       type: 'warning',
  //     })
  //
  //     .then( async() => {
  //       const param = {
  //         itemId: val.id,
  //         filePath: val.itemFile,
  //         userId: data.user.userId
  //       }
  //       const res = await signArchive(param)
  //       if(res.code == 200){
  //         ElMessage.success('项目归档成功')
  //         await getList()
  //       }else{
  //         ElMessage.warning(res.message)
  //       }
  //     })
}
/** 重置新增的表单以及其他数据  */
function reset() {
  data.queryParams = {
    pageNum: 1,
    pageSize: 10,
    status: ''
  }
  getList()
}
const handleDelete = (val) => {
  ElMessageBox.confirm(
      '确定删除此条数据？',
      '提示',
      {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning',
      })
      .then( async() => {
        const res = await delSignProject(val.id)
        if(res.code == 200){
          ElMessage.success('数据删除成功')
          await getList()
        }else{
          ElMessage.warning(res.message)
        }
      })
}


</script>
